<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/SymbolLookup/Scope.hh.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/SymbolLookup/Scope.hh</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/global.html" >Global Namespace</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/SymbolLookup/Scope.hh</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="comment">//</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="comment">// Copyright (C) 2004 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="comment">// All rights reserved.</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="comment">// Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="comment">// see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="comment">//</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line">#ifndef Synopsis_SymbolLookup_Scope_hh_</span>
<a id="line8"></a><span class="lineno">  8</span><span class="line">#define Synopsis_SymbolLookup_Scope_hh_</span>
<a id="line9"></a><span class="lineno">  9</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line">#include &lt;Synopsis/SymbolLookup/Symbol.hh&gt;</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line">#include &lt;map&gt;</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line">#include &lt;set&gt;</span>
<a id="line13"></a><span class="lineno"> 13</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="keyword">namespace</span> <a href="../../../Scopes/Synopsis.html" title="namespace Synopsis">Synopsis</a></span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line">{</span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line"><span class="keyword">namespace</span> <a href="../../../Scopes/Synopsis/SymbolLookup.html" title="namespace Synopsis::SymbolLookup">SymbolLookup</a></span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line">{</span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line"><span class="keyword">struct</span> <a href="../../../Scopes/Synopsis/SymbolLookup/TypeError.html" title="struct Synopsis::SymbolLookup::TypeError">TypeError</a> : <a href="" title="class std::exception">std::exception</a></span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line">{</span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line">  <a href="" title="member function Synopsis::SymbolLookup::TypeError::TypeError(const PTree::Encoding&amp;,const PTree::Encoding&amp;)">TypeError</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding const</a> &amp;n, <a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding const</a> &amp;t)</span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line">    : name(n), type(t) {}</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/SymbolLookup/TypeError.html#_tTypeError_l_r" title="member function Synopsis::SymbolLookup::TypeError::~TypeError()">~TypeError</a>() throw() {}</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line">  virtual <span class="keyword">char const</span> * <a href="../../../Scopes/Synopsis/SymbolLookup/TypeError.html#what_l_rconst" title="member function Synopsis::SymbolLookup::TypeError::what()const">what</a>() const throw() { <span class="keyword">return</span> <span class="string">&quot;TypeError&quot;</span>;}</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a> <a href="../../../Scopes/Synopsis/SymbolLookup/TypeError.html#name" title="data member Synopsis::SymbolLookup::TypeError::name">name</a>;</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a> <a href="../../../Scopes/Synopsis/SymbolLookup/TypeError.html#type" title="data member Synopsis::SymbolLookup::TypeError::type">type</a>;</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">};</span>
<a id="line27"></a><span class="lineno"> 27</span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line"><span class="keyword">struct</span> <a href="../../../Scopes/Synopsis/SymbolLookup/Undefined.html" title="struct Synopsis::SymbolLookup::Undefined">Undefined</a> : <a href="" title="class std::exception">std::exception</a></span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">{</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">  <a href="" title="member function Synopsis::SymbolLookup::Undefined::Undefined(const PTree::Encoding&amp;,const PTree::Node*)">Undefined</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding const</a> &amp;n, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node const</a> *ref = 0)</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">    : name(n), ptree(ref) {}</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/SymbolLookup/Undefined.html#_tUndefined_l_r" title="member function Synopsis::SymbolLookup::Undefined::~Undefined()">~Undefined</a>() throw() {}</span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">  virtual <span class="keyword">char const</span> * <a href="../../../Scopes/Synopsis/SymbolLookup/Undefined.html#what_l_rconst" title="member function Synopsis::SymbolLookup::Undefined::what()const">what</a>() const throw() { <span class="keyword">return</span> <span class="string">&quot;Undefined&quot;</span>;}</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>     <a href="../../../Scopes/Synopsis/SymbolLookup/Undefined.html#name" title="data member Synopsis::SymbolLookup::Undefined::name">name</a>;</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node const</a> * <a href="../../../Scopes/Synopsis/SymbolLookup/Undefined.html#ptree" title="data member Synopsis::SymbolLookup::Undefined::ptree">ptree</a>;</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">};</span>
<a id="line37"></a><span class="lineno"> 37</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line"><span class="keyword">struct</span> <a href="../../../Scopes/Synopsis/SymbolLookup/MultiplyDefined.html" title="struct Synopsis::SymbolLookup::MultiplyDefined">MultiplyDefined</a> : <a href="" title="class std::exception">std::exception</a></span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">{</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">  <a href="" title="member function Synopsis::SymbolLookup::MultiplyDefined::MultiplyDefined(const PTree::Encoding&amp;,const PTree::Node*,const PTree::Node*)">MultiplyDefined</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding const</a> &amp;n,</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">		  <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node const</a> *decl,</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">		  <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node const</a> *orig)</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">    : name(n), declaration(decl), original(orig) {}</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/SymbolLookup/MultiplyDefined.html#_tMultiplyDefined_l_r" title="member function Synopsis::SymbolLookup::MultiplyDefined::~MultiplyDefined()">~MultiplyDefined</a>() throw() {}</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">  virtual <span class="keyword">char const</span> * <a href="../../../Scopes/Synopsis/SymbolLookup/MultiplyDefined.html#what_l_rconst" title="member function Synopsis::SymbolLookup::MultiplyDefined::what()const">what</a>() const throw() { <span class="keyword">return</span> <span class="string">&quot;MultiplyDefined&quot;</span>;}</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a> <a href="../../../Scopes/Synopsis/SymbolLookup/MultiplyDefined.html#name" title="data member Synopsis::SymbolLookup::MultiplyDefined::name">name</a>;</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node const</a> * <a href="../../../Scopes/Synopsis/SymbolLookup/MultiplyDefined.html#declaration" title="data member Synopsis::SymbolLookup::MultiplyDefined::declaration">declaration</a>;</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node const</a> * <a href="../../../Scopes/Synopsis/SymbolLookup/MultiplyDefined.html#original" title="data member Synopsis::SymbolLookup::MultiplyDefined::original">original</a>;</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">};</span>
<a id="line50"></a><span class="lineno"> 50</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/SymbolLookup/InternalError.html" title="class Synopsis::SymbolLookup::InternalError">InternalError</a> : <span class="keyword">public</span> <a href="" title="class std::exception">std::exception</a></span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">{</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">  <a href="" title="member function Synopsis::SymbolLookup::InternalError::InternalError(const std::string&amp;)">InternalError</a>(<a href="" title="typedef std::string">std::string const</a> &amp;what) : my_what(what) {}</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/SymbolLookup/InternalError.html#_tInternalError_l_r" title="member function Synopsis::SymbolLookup::InternalError::~InternalError()">~InternalError</a>() throw() {}</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">  virtual <span class="keyword">char const</span> * <a href="../../../Scopes/Synopsis/SymbolLookup/InternalError.html#what_l_rconst" title="member function Synopsis::SymbolLookup::InternalError::what()const">what</a>() const throw() { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/SymbolLookup/InternalError.html#my_what" title="data member Synopsis::SymbolLookup::InternalError::my_what">my_what</a>.c_str();}</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">  <a href="" title="typedef std::string">std::string</a> <a href="../../../Scopes/Synopsis/SymbolLookup/InternalError.html#my_what" title="data member Synopsis::SymbolLookup::InternalError::my_what">my_what</a>;</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">};</span>
<a id="line60"></a><span class="lineno"> 60</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line"><span class="keyword">typedef</span> std::<a href="" title="class std::set">set</a>&lt;<a href="../../../Scopes/Synopsis/SymbolLookup/Symbol.html" title="class Synopsis::SymbolLookup::Symbol">Symbol const</a> *&gt; <a href="../../../Scopes/Synopsis/SymbolLookup.html#SymbolSet" title="typedef Synopsis::SymbolLookup::SymbolSet">SymbolSet</a>;</span>
<a id="line62"></a><span class="lineno"> 62</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">class ScopeVisitor;</span>
<a id="line64"></a><span class="lineno"> 64</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line"><span class="comment">//. A Scope contains symbol definitions.</span></span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope</a></span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">{</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line"><span class="keyword">protected</span>:</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">  //. SymbolTable provides a mapping from (encoded) names to Symbols declared</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">  //. in this scope.</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">  <span class="keyword">typedef</span> std::<a href="" title="class std::multimap">multimap</a>&lt;<a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>, Symbol const *&gt; <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#SymbolTable" title="typedef Synopsis::SymbolLookup::Scope::SymbolTable">SymbolTable</a>;</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">  //. ScopeTable provides a mapping from scope nodes to Scopes,</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">  //. which can be used to traverse the scope tree in parallel with</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">  //. the associated parse tree. As this traversal is also done</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">  //. during the parsing, the scopes can not be const.</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">  <span class="keyword">typedef</span> std::<a href="" title="class std::map">map</a>&lt;<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node const</a> *, Scope *&gt; <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#ScopeTable" title="typedef Synopsis::SymbolLookup::Scope::ScopeTable">ScopeTable</a>;</span>
<a id="line77"></a><span class="lineno"> 77</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">  <span class="keyword">typedef</span> SymbolTable::const_iterator <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#symbol_iterator" title="typedef Synopsis::SymbolLookup::Scope::symbol_iterator">symbol_iterator</a>;</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">  <span class="keyword">typedef</span> ScopeTable::const_iterator <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#scope_iterator" title="typedef Synopsis::SymbolLookup::Scope::scope_iterator">scope_iterator</a>;</span>
<a id="line81"></a><span class="lineno"> 81</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">  <span class="keyword">typedef</span> <span class="keyword">unsigned int</span> <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#LookupContext" title="typedef Synopsis::SymbolLookup::Scope::LookupContext">LookupContext</a>;</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">  static <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#LookupContext" title="typedef Synopsis::SymbolLookup::Scope::LookupContext">LookupContext const</a> <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#DEFAULT" title="data member Synopsis::SymbolLookup::Scope::DEFAULT">DEFAULT</a> = <span class="literal">0x0</span>;</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">  static <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#LookupContext" title="typedef Synopsis::SymbolLookup::Scope::LookupContext">LookupContext const</a> <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#SCOPE" title="data member Synopsis::SymbolLookup::Scope::SCOPE">SCOPE</a> = <span class="literal">0x1</span>; <span class="comment">// lookup a scope, see [basic.lookup.qual]</span></span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">  static <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#LookupContext" title="typedef Synopsis::SymbolLookup::Scope::LookupContext">LookupContext const</a> <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#USING" title="data member Synopsis::SymbolLookup::Scope::USING">USING</a> = <span class="literal">0x2</span>; <span class="comment">// lookup in the context of a using directive</span></span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">  static <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#LookupContext" title="typedef Synopsis::SymbolLookup::Scope::LookupContext">LookupContext const</a> <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#ELABORATE" title="data member Synopsis::SymbolLookup::Scope::ELABORATE">ELABORATE</a> = <span class="literal">0x4</span>; <span class="comment">// elaborate name lookup</span></span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">  static <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#LookupContext" title="typedef Synopsis::SymbolLookup::Scope::LookupContext">LookupContext const</a> <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#DECLARATION" title="data member Synopsis::SymbolLookup::Scope::DECLARATION">DECLARATION</a> = <span class="literal">0x8</span>; <span class="comment">// see 3.4.3.2/6 [namespace.qual]</span></span>
<a id="line88"></a><span class="lineno"> 88</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#Scope_l_r" title="member function Synopsis::SymbolLookup::Scope::Scope()">Scope</a>() : my_refcount(1) {}</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope</a> *<a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#ref_l_r" title="member function Synopsis::SymbolLookup::Scope::ref()">ref</a>() { ++<a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#my_refcount" title="data member Synopsis::SymbolLookup::Scope::my_refcount">my_refcount</a>; <span class="keyword">return</span> <span class="keyword">this</span>;}</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope const</a> *<a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#ref_l_rconst" title="member function Synopsis::SymbolLookup::Scope::ref()const">ref</a>() const { ++<a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#my_refcount" title="data member Synopsis::SymbolLookup::Scope::my_refcount">my_refcount</a>; <span class="keyword">return</span> <span class="keyword">this</span>;}</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#unref_l_rconst" title="member function Synopsis::SymbolLookup::Scope::unref()const">unref</a>() const { <span class="keyword">if</span> (!--<a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#my_refcount" title="data member Synopsis::SymbolLookup::Scope::my_refcount">my_refcount</a>) <span class="keyword">delete</span> <span class="keyword">this</span>;}</span>
<a id="line93"></a><span class="lineno"> 93</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope const</a> *<a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#outer_scope_l_rconst" title="member function Synopsis::SymbolLookup::Scope::outer_scope()const">outer_scope</a>() const = 0;</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope const</a> *<a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#global_scope_l_rconst" title="member function Synopsis::SymbolLookup::Scope::global_scope()const">global_scope</a>() const;</span>
<a id="line96"></a><span class="lineno"> 96</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#accept_lScopeVisitor_S_r" title="member function Synopsis::SymbolLookup::Scope::accept(ScopeVisitor*)">accept</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/ScopeVisitor.html" title="class Synopsis::SymbolLookup::ScopeVisitor">ScopeVisitor</a> *v) = 0;</span>
<a id="line98"></a><span class="lineno"> 98</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#symbol_iterator" title="typedef Synopsis::SymbolLookup::Scope::symbol_iterator">symbol_iterator</a> <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#symbols_begin_l_rconst" title="member function Synopsis::SymbolLookup::Scope::symbols_begin()const">symbols_begin</a>() const { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#my_symbols" title="data member Synopsis::SymbolLookup::Scope::my_symbols">my_symbols</a>.<a href="" title="member function std::multimap::begin()">begin</a>();}</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#symbol_iterator" title="typedef Synopsis::SymbolLookup::Scope::symbol_iterator">symbol_iterator</a> <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#symbols_end_l_rconst" title="member function Synopsis::SymbolLookup::Scope::symbols_end()const">symbols_end</a>() const { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#my_symbols" title="data member Synopsis::SymbolLookup::Scope::my_symbols">my_symbols</a>.<a href="" title="member function std::multimap::end()">end</a>();}</span>
<a id="line101"></a><span class="lineno">101</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#scope_iterator" title="typedef Synopsis::SymbolLookup::Scope::scope_iterator">scope_iterator</a> <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#scopes_begin_l_rconst" title="member function Synopsis::SymbolLookup::Scope::scopes_begin()const">scopes_begin</a>() const { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#my_scopes" title="data member Synopsis::SymbolLookup::Scope::my_scopes">my_scopes</a>.<a href="" title="member function std::map::begin()">begin</a>();}</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#scope_iterator" title="typedef Synopsis::SymbolLookup::Scope::scope_iterator">scope_iterator</a> <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#scopes_end_l_rconst" title="member function Synopsis::SymbolLookup::Scope::scopes_end()const">scopes_end</a>() const { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#my_scopes" title="data member Synopsis::SymbolLookup::Scope::my_scopes">my_scopes</a>.<a href="" title="member function std::map::end()">end</a>();}</span>
<a id="line104"></a><span class="lineno">104</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">  <span class="comment">//. declare the given symbol in the local scope </span></span>
<a id="line106"></a><span class="lineno">106</span><span class="line"><span class="comment">  //. using the given encoded name.</span></span>
<a id="line107"></a><span class="lineno">107</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolLookup::Scope::declare(const PTree::Encoding&amp;,const Symbol*)">declare</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding const</a> &amp;name, <a href="../../../Scopes/Synopsis/SymbolLookup/Symbol.html" title="class Synopsis::SymbolLookup::Symbol">Symbol const</a> *symbol);</span>
<a id="line108"></a><span class="lineno">108</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">  <span class="comment">//. declare a nested scope</span></span>
<a id="line110"></a><span class="lineno">110</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolLookup::Scope::declare_scope(const PTree::Node*,Scope*)">declare_scope</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node const</a> *, <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope</a> *);</span>
<a id="line111"></a><span class="lineno">111</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">  <span class="comment">//. declare a 'using' directive.</span></span>
<a id="line113"></a><span class="lineno">113</span><span class="line"><span class="comment">  //. The default implementation raises an exception,</span></span>
<a id="line114"></a><span class="lineno">114</span><span class="line"><span class="comment">  //. as it is only well-formed when the current scope</span></span>
<a id="line115"></a><span class="lineno">115</span><span class="line"><span class="comment">  //. is a function scope or a namespace.</span></span>
<a id="line116"></a><span class="lineno">116</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolLookup::Scope::use(const PTree::UsingDirective*)">use</a>(<a href="../../../Scopes/Synopsis/PTree/UsingDirective.html" title="class Synopsis::PTree::UsingDirective">PTree::UsingDirective const</a> *);</span>
<a id="line117"></a><span class="lineno">117</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">  <span class="comment">//. find a nested scope by declaration</span></span>
<a id="line119"></a><span class="lineno">119</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope</a> *<a href="" title="member function Synopsis::SymbolLookup::Scope::find_scope(const PTree::Node*)const">find_scope</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node const</a> *) const;</span>
<a id="line120"></a><span class="lineno">120</span><span class="line">  <span class="comment">//. find a nested scope by symbol.</span></span>
<a id="line121"></a><span class="lineno">121</span><span class="line"><span class="comment">  //. The encoded name is provided for diagnostic purposes only.</span></span>
<a id="line122"></a><span class="lineno">122</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope</a> *<a href="" title="member function Synopsis::SymbolLookup::Scope::find_scope(const PTree::Encoding&amp;,const Symbol*)const">find_scope</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding const</a> &amp;, <a href="../../../Scopes/Synopsis/SymbolLookup/Symbol.html" title="class Synopsis::SymbolLookup::Symbol">Symbol const</a> *) const;</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">  <span class="comment">//. Remove the given nested scope from the scope.</span></span>
<a id="line124"></a><span class="lineno">124</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolLookup::Scope::remove_scope(const PTree::Node*)">remove_scope</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node const</a>*);</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">  <span class="comment">//. find a nested scope by name</span></span>
<a id="line126"></a><span class="lineno">126</span><span class="line"><span class="comment">  //Scope *find_scope(PTree::Encoding const &amp;) const;</span></span>
<a id="line127"></a><span class="lineno">127</span>
<a id="line128"></a><span class="lineno">128</span><span class="line">  <span class="comment">//. find the encoded name declared in this scope and </span></span>
<a id="line129"></a><span class="lineno">129</span><span class="line"><span class="comment">  //. return a set of matching symbols.</span></span>
<a id="line130"></a><span class="lineno">130</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup.html#SymbolSet" title="typedef Synopsis::SymbolLookup::SymbolSet">SymbolSet</a> <a href="" title="member function Synopsis::SymbolLookup::Scope::find(const PTree::Encoding&amp;,LookupContext)const">find</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding const</a> &amp;, <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#LookupContext" title="typedef Synopsis::SymbolLookup::Scope::LookupContext">LookupContext</a>) const throw();</span>
<a id="line131"></a><span class="lineno">131</span><span class="line">  <span class="comment">//. Remove the given symbol from the scope.</span></span>
<a id="line132"></a><span class="lineno">132</span><span class="line"><span class="comment">  //. s shall not be used after its removal.</span></span>
<a id="line133"></a><span class="lineno">133</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#remove_lconst.Symbol_S_r" title="member function Synopsis::SymbolLookup::Scope::remove(const Symbol*)">remove</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/Symbol.html" title="class Synopsis::SymbolLookup::Symbol">Symbol const</a> *s);</span>
<a id="line134"></a><span class="lineno">134</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">  <span class="comment">//. look up the encoded name and return a set of matching symbols.</span></span>
<a id="line136"></a><span class="lineno">136</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup.html#SymbolSet" title="typedef Synopsis::SymbolLookup::SymbolSet">SymbolSet</a> <a href="" title="member function Synopsis::SymbolLookup::Scope::lookup(const PTree::Encoding&amp;,LookupContext)const">lookup</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding const</a> &amp;, <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#LookupContext" title="typedef Synopsis::SymbolLookup::Scope::LookupContext">LookupContext</a> = DEFAULT) const;</span>
<a id="line137"></a><span class="lineno">137</span>
<a id="line138"></a><span class="lineno">138</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/SymbolLookup.html#SymbolSet" title="typedef Synopsis::SymbolLookup::SymbolSet">SymbolSet</a> <a href="" title="member function Synopsis::SymbolLookup::Scope::unqualified_lookup(const PTree::Encoding&amp;,LookupContext)const">unqualified_lookup</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding const</a> &amp;,</span>
<a id="line139"></a><span class="lineno">139</span><span class="line">				       <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#LookupContext" title="typedef Synopsis::SymbolLookup::Scope::LookupContext">LookupContext</a> = DEFAULT) const = 0;</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/SymbolLookup.html#SymbolSet" title="typedef Synopsis::SymbolLookup::SymbolSet">SymbolSet</a> <a href="" title="member function Synopsis::SymbolLookup::Scope::qualified_lookup(const PTree::Encoding&amp;,LookupContext)const">qualified_lookup</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding const</a> &amp;,</span>
<a id="line141"></a><span class="lineno">141</span><span class="line">				     <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#LookupContext" title="typedef Synopsis::SymbolLookup::Scope::LookupContext">LookupContext</a> = DEFAULT) const;</span>
<a id="line142"></a><span class="lineno">142</span>
<a id="line143"></a><span class="lineno">143</span><span class="line"><span class="keyword">protected</span>:</span>
<a id="line144"></a><span class="lineno">144</span>
<a id="line145"></a><span class="lineno">145</span><span class="line">  <span class="comment">//. Scopes are ref counted, and thus are deleted only by 'unref()'</span></span>
<a id="line146"></a><span class="lineno">146</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#_tScope_l_r" title="member function Synopsis::SymbolLookup::Scope::~Scope()">~Scope</a>();</span>
<a id="line147"></a><span class="lineno">147</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#SymbolTable" title="typedef Synopsis::SymbolLookup::Scope::SymbolTable">SymbolTable</a>    <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#my_symbols" title="data member Synopsis::SymbolLookup::Scope::my_symbols">my_symbols</a>;</span>
<a id="line149"></a><span class="lineno">149</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#ScopeTable" title="typedef Synopsis::SymbolLookup::Scope::ScopeTable">ScopeTable</a>     <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#my_scopes" title="data member Synopsis::SymbolLookup::Scope::my_scopes">my_scopes</a>;</span>
<a id="line150"></a><span class="lineno">150</span><span class="line">  mutable <a href="" title="typedef size_t">size_t</a> <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#my_refcount" title="data member Synopsis::SymbolLookup::Scope::my_refcount">my_refcount</a>;</span>
<a id="line151"></a><span class="lineno">151</span><span class="line">};</span>
<a id="line152"></a><span class="lineno">152</span>
<a id="line153"></a><span class="lineno">153</span><span class="line">inline <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolLookup::Scope::declare_scope(const PTree::Node*,Scope*)">Scope::declare_scope</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node const</a> *node, <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope</a> *scope)</span>
<a id="line154"></a><span class="lineno">154</span><span class="line">{</span>
<a id="line155"></a><span class="lineno">155</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#my_scopes" title="data member Synopsis::SymbolLookup::Scope::my_scopes">my_scopes</a>[<a href="" title="parameter node">node</a>] = <a href="" title="parameter scope">scope</a>-&gt;<a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#ref_l_r" title="member function Synopsis::SymbolLookup::Scope::ref()">ref</a>();</span>
<a id="line156"></a><span class="lineno">156</span><span class="line">}</span>
<a id="line157"></a><span class="lineno">157</span>
<a id="line158"></a><span class="lineno">158</span><span class="line">inline Scope *Scope::find_scope(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node const</a> *node) const</span>
<a id="line159"></a><span class="lineno">159</span><span class="line">{</span>
<a id="line160"></a><span class="lineno">160</span><span class="line">  ScopeTable::const_iterator i = my_scopes.find(node);</span>
<a id="line161"></a><span class="lineno">161</span><span class="line">  return i == my_scopes.end() ? 0 : i-&gt;second;</span>
<a id="line162"></a><span class="lineno">162</span><span class="line">}</span>
<a id="line163"></a><span class="lineno">163</span>
<a id="line164"></a><span class="lineno">164</span><span class="line">inline Scope const *Scope::global_scope() const</span>
<a id="line165"></a><span class="lineno">165</span><span class="line">{</span>
<a id="line166"></a><span class="lineno">166</span><span class="line">  Scope const *scope = this;</span>
<a id="line167"></a><span class="lineno">167</span><span class="line">  while (Scope const *outer = scope-&gt;outer_scope())</span>
<a id="line168"></a><span class="lineno">168</span><span class="line">    scope = outer;</span>
<a id="line169"></a><span class="lineno">169</span><span class="line">  return scope;</span>
<a id="line170"></a><span class="lineno">170</span><span class="line">}</span>
<a id="line171"></a><span class="lineno">171</span>
<a id="line172"></a><span class="lineno">172</span><span class="line">}</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">}</span>
<a id="line174"></a><span class="lineno">174</span>
<a id="line175"></a><span class="lineno">175</span><span class="line">#endif</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:28:03 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
